﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;
using System.IO;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Drawing;
using Syncfusion.Pdf.Grid;

namespace GettingStarted
{
	public partial class MainPage : ContentPage
	{
		public MainPage()
		{
			InitializeComponent();
		}

        void OnButtonClicked(object sender, EventArgs args)
        {
            // Create a new PDF document
            PdfDocument document = new PdfDocument();

            //Add a page to the document
            PdfPage page = document.Pages.Add();

            //Create PDF graphics for the page
            PdfGraphics graphics = page.Graphics;

            //List of Columns
            List<Customer> collection = new List<Customer>();

            Customer customer = new Customer();
            customer.Date = DateTime.Now.ToString();
            customer.LabelfromPost = "Thomas";
            collection.Add(customer);

            customer = new Customer();
            customer.Date = DateTime.Now.ToString();
            customer.LabelfromPost = "Andrew";
            collection.Add(customer);

            //Create a PdfGrid
            PdfGrid pdfGrid = new PdfGrid();

            //Add values to list
            List<object> data = new List<object>();

            for (int i = 0; i < collection.Count; i++)
            {
                Object row = new { Date = collection[i].Date, LabelfromPost = collection[i].LabelfromPost };
                data.Add(row);
            }

            //Add list to IEnumerable
            IEnumerable<object> tableData = data;

            //Assign data source
            pdfGrid.DataSource = tableData;

            //Draw grid to the page of PDF document
            pdfGrid.Draw(page, new PointF(10, 10));

            //Save the document to the stream
            MemoryStream stream = new MemoryStream();
            document.Save(stream);

            //Close the document
            document.Close(true);

            //Save the stream as a file in the device and invoke it for viewing
            Xamarin.Forms.DependencyService.Get<ISave>().SaveAndView("Output.pdf", "application/pdf", stream);
        }

    }

    class Customer
    {
        private string m_date;
        private string m_label;
        public string Date
        {
            get
            {
                return m_date;
            }
            set
            {
                m_date = value;
            }
        }
        public string LabelfromPost
        {
            get
            {
                return m_label;
            }
            set
            {
                m_label = value;
            }
        }

    }
}
